<?php
class ItemDao{

  private $mysqli = null;

  //コンストラクタ
  function __construct(){
    $this->connect();
  }

  //デストラクタ
  function __destruct(){
    $this->disconnect();
  }

  //MySQLサーバへ接続
  private function connect(){
    if(is_null($this->mysqli)){
      $this->mysqli = new mysqli("localhost", "php", "password", "sample_db2");
      $this->mysqli->query("SET NAMES utf8");
      if(mysqli_connect_errno()){
	die("MySQLサーバ接続に失敗しました<br> 理由：" . mysqli_connect_error());
      }
    }
  }

  //MySQLサーバと切断
  private function disconnect(){
    is_null($this->mysqli) or $this->mysqli->close();
  }


  //全アイテムの取得
  public function getAllItem(){
    is_null($this->mysqli) and $this->connect();
    $result = $this->mysqli->query("SELECT * FROM item");
    $item_array = array();

    while($row = $result->fetch_array(MYSQLI_ASSOC)){  ##<--MYSQLI_NUMではなく
      $item = new Item();
      $item->setId($row["id"]);
      $item->setName($row["name"]);
      $item->setDetail($row["detail"]);
      $item->setPrice($row["price"]);
      $item->setQty($row["qty"]);
      $item_array[] = $item;      
    }
    $result->close();
    return $item_array;
  }

  //指定されたアイテムの取得
  private function getItem($sql){
    is_null($this->mysqli) and $this->connect();
    $result = $this->mysqli->query($sql);

    $item = null;

    if($result->num_rows != 0){
      $row = $result->fetch_array(MYSQLI_ASSOC);
      $item = new Item();
      $item->setId($row["id"]);
      $item->setName($row["name"]);
      $item->setDetail($row["detail"]);
      $item->setPrice($row["price"]);
      $item->setQty($row["qty"]);
    }
    $result->close();

    return $item;
  }

  //idでアイテムを取得
  public function getItemById($id){
    $sql = "SELECT * FROM item WHERE id = '$id'";
    return $this->getItem($sql);
  }

  //nameでアイテムを取得
  public function getItemByName($name){
    $sql = "SELECT * FROM item WHERE name = '$name'";
    return $this->getItem($sql);
  }

  //アイテムの更新
  public function updateItem($item){
    is_null($this->mysqli) and $this->connect();
    $sql = "UPDATE item SET
                         name = '" . $item->getName() . "',
                         detail = '" . $item->getDetail() . "',
                         price = '" . $item->getPrice() . "',
                         qty ='" . $item->getQty() . "'
            WHERE id = '" . $item->getId() . "'";
    if( !$this->mysqli->query($sql)){
      print "登録に失敗しました(1001) " . $this->mysqli->error . "\n";
    }
  }

  //新規アイテムの登録
  public function insertItem($item){
    is_null($this->mysqli) and $this->connect();
    $sql = "INSERT INTO item values ('',  #idカラムに空を挿入することで，auto_incrementによるカウントアップ値を代入できる
                         '" . $item->getName() . "',
                         '" . $item->getDetail() . "',
                         '" . $item->getPrice() . "',
                         '" . $item->getQty() . "')";
    if( !$this->mysqli->query($sql)){
      print "登録に失敗しました(1002) " . $this->mysqli->error . "\n";
    }
  }

  //指定されたアイテムの削除
  public function deleteItem($item){
    $this->deleteItemById($item->getId());
  }

  //idで指定されたアイテムの削除
  public function deleteItemById($id){
    is_null($this->mysqli) and $this->connect();

    $sql = "DELETE FROM item WHERE id = '" . $id . "'";
    if( !$this->mysqli->query($sql)){
      print "削除に失敗しました(1003) " . $this->mysqli->error . "\n";
    }
  }

}
?>
